#Encoding: UTF-8
class SolutionsController < ApplicationController
  before_filter :init_user

  def show
    if @user
      if @user.student?
        @solutions=@user.solutions
      else
        if !params[:task_id].nil?
          task = Task.find_by_number params[:task_id]
          @solutions= task.solutions
        else
          @solutions = Array.new
          tasks = Task.find :all
          tasks.each do |task| 
            task.solutions.each do |s|
              @solutions << s
            end
          end
        end
      end
    end
  end

  def new
  end

  def edit
    if params[:task_id].nil?
      redirect_to :action => "show"
    end
    if params[:user_id].nil?
      task = Task.find params[:task_id]
      redirect_to :action => "show", :task_id=>task.number
    end
    if @user
      if @user.student?
      else
        @solution=Solution.find_by_task_id_and_user_id params[:task_id], params[:user_id]
      end
    end
  end
  
  def update
    @solution = Solution.find params[:id]
    s = params[:solution]
    @solution.late = s[:late].to_i
    @solution.accepted = s[:accepted].to_i
    @solution.comment = s[:comment]
    @solution.save
    redirect_to :action=>"show",:task_id=>@solution.task.number
  end
  
  def download
    file = "public/_index.html"
    send_file file
    #render :show, :id=>params[:id].task.number
  end

  private
  def init_user
    @user = User.find session[:user]
  end
end
